/* ------------------------------------------------
                  oled_demo_i2c.c

   Auf I2C-Display reduziertes Demoversion
   von tft_mono, nur fuer SSD1306 - I2C Display

   MCU   :  CH32V003
   Takt  :

   12.06.2025 by R. Seelig
  -------------------------------------------------- */


#include <stdlib.h>                             // fuer abs()
#include "ch32fun.h"
#include "ch32v003_gpio.h"

#include "oled_i2c.h"

#include "my_printf.h"

#include "girl25_01.h"

#define printf       my_printf

#define demo_speed    2000


/* --------------------------------------------------------
   putchar

   wird von my-printf / printf aufgerufen und hier muss
   eine Zeichenausgabefunktion angegeben sein, auf das
   printf dann schreibt !
   -------------------------------------------------------- */
void my_putchar(char ch)
{
  lcd_putchar(ch);
}


/* ------------------------------------------------------------------------
                                    MAIN
   ------------------------------------------------------------------------ */

int main(void)
{
  int ascii;
  int     x, y;

  SystemInit();
  lcd_init();

  setfont(fnt8x8);
  fb_init(127,8);

  while(1)

  {
    clrscr();

    // Screen 1
    fb_clear();
    fb_show(0,0);

    fillcircle(28,32,20,1);
    circle(60,39,24,2);
    fillrect(64,32,100,64,2);
    line(0,0,127,63,2);

    fb_outtextxy(0,0, "Framebuffer");
    fb_show(0,0);

    delay(demo_speed);

    // Screen 2
    clrscr();
    fb_clear();

    for (x= 0; x<128; x+= 8)
    {
      line(0,63, x,0, 1);
      fb_show(0,0);
    }

    // Screen 3
    for (y= 4; y< 64; y+= 8)
    {
      line(0,63, 127,y, 1);
      fb_show(0,0);
    }
    delay(demo_speed);

    // Screen 3b
    fb_clear();
    y= 0;
    for(x= 0; x <128; x+=16)
    {
      line(x, 0, 128, y, 1);
      line(128-x, 64, 0, 64 - y, 1);
      y+= 8;
    }
    fb_outtextxy(26,30, "Hallo Welt");
    fb_show(0,0);

    delay(demo_speed);

    // Screen 4
    showimage(0,0, &bmpsw_image[0], 1);

    delay(demo_speed);
    
    clrscr();
    // Screen 5

    printf("ASCII - Zeichen!\n\r");
    for (x= 0; x< 16; x++) { lcd_putchar(205); }
    for (ascii= 32; ascii< 128; ascii++)
    {
      if ((ascii % 16)== 0) { printf("\n\r"); }
      my_putchar(ascii);
    }
    delay(demo_speed);

    // Screen 6
    setfont(fnt8x8);
    textsize= 0;
    clrscr();
    gotoxy(0,0);
    printf("Normalgroesse\n\r");
    textsize= 2;
    printf("\n\rGROSS");
    textsize= 0;
    printf("\n\n\rklein\n\r");
    delay(demo_speed);
  }

}
